package com.offline.music.task.player.ui.adapter

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.offline.music.task.player.ProApp
import com.offline.music.task.player.R
import com.offline.music.task.player.databinding.ParentsVoiceLayoutBinding
import com.offline.music.task.player.db.bean.Audio
import com.offline.music.task.player.tools.util.containsContent
import com.offline.music.task.player.tools.util.convertMillisToMinutesAndSecondsString
import com.offline.music.task.player.tools.util.getAudioDurationFromAssets
import com.offline.music.task.player.ui.activity.PlayerActivity

//LOGO
class MeLocalSongAdapter(
    private val context: Context,
    private val pdfList: List<Audio>,
) :
    RecyclerView.Adapter<MeLocalSongAdapter.ViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val binding = ParentsVoiceLayoutBinding.inflate(LayoutInflater.from(context), parent, false)
        return ViewHolder(binding)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val audio = pdfList[position]
        holder.bind(audio)
        holder.itemView.setOnClickListener {
            val intent = Intent(context, PlayerActivity::class.java);
            intent.putExtra(PlayerActivity.KEY_DETAILS_AUDIO, audio)
            context.startActivity(intent)
        }
    }

    override fun getItemCount(): Int = pdfList.size

    inner class ViewHolder(private val binding: ParentsVoiceLayoutBinding) :
        RecyclerView.ViewHolder(binding.root) {

        fun bind(audio: Audio) {
            binding.apply {
                image.setImageResource(R.mipmap.default_list_img)
                name.text = audio.name
                name.requestFocus()
                if (containsContent(audio.file)) {
                    desc.text = convertMillisToMinutesAndSecondsString(audio.duration)
                } else {
                    val s = getAudioDurationFromAssets(context, audio.file)
                    desc.text = convertMillisToMinutesAndSecondsString(s)
                }

                if (ProApp.currentPlayingAudio != null) {
                    if (ProApp.currentPlayingAudio?.file == audio.file) {
                        playingLayout.visibility = View.VISIBLE
                        name.setTextColor(context.getColor(R.color.blue))
                        desc.setTextColor(context.getColor(R.color.blue))
                    } else {
                        playingLayout.visibility = View.GONE
                        name.setTextColor(context.getColor(R.color.white))
                        desc.setTextColor(context.getColor(R.color.white_60))
                    }
                }
            }
        }
    }
}